/*********************************************************************
 * 
 *  Test Graphics
 *  Gamblore
 */
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>

#include "draw.c"
#include "homebutton.c"

#define printf	pspDebugScreenPrintf
PSP_MODULE_INFO("Tag", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

/* game structs and variables */

typedef struct{
	int x;
	int y;
	short isChaser;
} player;

player one = {70,238,1};
player two = {300,60,0};
int immune = 0;

//-------------------------------------------------------------------------------------------------
void drawPlayer(player t, u32 colour){
	drawLineY(t.x,t.y,10,colour);
	drawLineY(t.x+1,t.y,10,colour);
	drawLineY(t.x+2,t.y,10,colour);
	drawLineY(t.x+3,t.y,10,colour);
	drawLineY(t.x+4,t.y,10,colour);
	drawLineY(t.x+5,t.y,10,colour);
	drawLineY(t.x+6,t.y,10,colour);
	if (t.isChaser == 1)
	{
		drawLineY(t.x+4,t.y+2,7,BLACK);
		drawLineY(t.x+5,t.y+2,7,BLACK);
		drawLineY(t.x+6,t.y+2,7,BLACK);
	}
	drawLineY(t.x+7,t.y,10,colour);
	drawLineY(t.x+8,t.y,10,colour);
	drawLineY(t.x+9,t.y,10,colour);
	if (t.isChaser == 1)
	{
	drawLineX(t.x+2,t.y+4,7,BLACK);
	drawLineX(t.x+2,t.y+5,7,BLACK);
	drawLineX(t.x+2,t.y+6,7,BLACK);
	}
}

//-------------------------------------------------------------------------------------------------
void drawScreen(){
	pgScreenFlip();
	ClearScreen(BLACK);
	drawPlayer(one,RED);
	drawPlayer(two,WHITE);

	
}

//-------------------------------------------------------------------------------------------------
void movePlayer1(int dirX, int dirY){ // -1 left 1 right 0 dont move
													  // -1 up 1 down 0 dont move
	// moving left right
	if (dirX == -1){
		one.x = one.x - 3;
	} else if (dirX == 1){
		one.x = one.x + 3;
	} else if (dirX == 0){}
	
	// moving up down
	if (dirY == -1){
		one.y = one.y - 3;
	} else if (dirY == 1){
		one.y = one.y + 3;
	} else if (dirY == 0){}
	
	// left right check
	if (one.x < 0){
		one.x = 0;
	} else if (one.x > 470){
		one.x = 470;
	} 
	
	// top bottom check
	if (one.y < 0){
		one.y = 0;
	} else if (one.y > 261){
		one.y = 261;
	}
	
}
//-------------------------------------------------------------------------------------------------
void movePlayer2(int dirX, int dirY){ // -1 left 1 right 0 dont move
													  // -1 up 1 down 0 dont move
	// moving left right
	if (dirX == -1){
		two.x = two.x - 3;
	} else if (dirX == 1){
		two.x = two.x + 3;
	} else if (dirX == 0){}
	
	// moving up down
	if (dirY == -1){
		two.y = two.y - 3;
	} else if (dirY == 1){
		two.y = two.y + 3;
	} else if (dirY == 0){}
	
	// left right check
	if (two.x < 0){
		two.x = 0;
	} else if (two.x > 470){
		two.x = 470;
	} 
	
	// top bottom check
	if (two.y < 0){
		two.y = 0;
	} else if (two.y > 261){
		two.y = 261;
	}
	
}

//-------------------------------------------------------------------------------------------------
void switchChaser(){
	if (one.isChaser == 1)
	{
		one.isChaser = 0;
		two.isChaser = 1;
		//chaser = "Two";
	}
	else
	{
		one.isChaser = 1;
		two.isChaser = 0;
		//chaser = "One";
	}
	immune = 30;
}

//-------------------------------------------------------------------------------------------------
void testContact(){
	if (immune == 0){
	
		if(one.x-10 <= two.x && one.x+10 >= two.x && one.y-10 <= two.y && one.y+10 >= two.y){
		
			switchChaser();
				
			}
		}
	else if(immune != 0){
		immune--;
	}
	
}


//-------------------------------------------------------------------------------------------------
void keyboardControl()
{
	SceCtrlData ctrl;
	sceDisplayWaitVblankStart();
	sceCtrlReadBufferPositive(&ctrl, 1); 
	if (ctrl.Buttons != 0){
	if (ctrl.Buttons & PSP_CTRL_UP) { 
		movePlayer1(0,-1);
	} if (ctrl.Buttons & PSP_CTRL_LEFT) { 
		movePlayer1(-1,0);
	} if (ctrl.Buttons & PSP_CTRL_RIGHT) { 
		movePlayer1(1,0);
	} if (ctrl.Buttons & PSP_CTRL_DOWN) { 
		movePlayer1(0,1);
	} if (ctrl.Buttons & PSP_CTRL_CIRCLE) {
		movePlayer2(1,0);
	}if (ctrl.Buttons & PSP_CTRL_CROSS) {
		movePlayer2(0,1);
	}if (ctrl.Buttons & PSP_CTRL_TRIANGLE) {
		movePlayer2(0,-1);
	}if (ctrl.Buttons & PSP_CTRL_SQUARE) {
		movePlayer2(-1,0);
	}
	}
}

//-------------------------------------------------------------------------------------------------
int main(int argc,char *argv[]){
	SetupCallbacks();
	InitScreen();
	
	pgScreenFrame(1, 1);
	pgFlipDrawFrame();
	ClearScreen(BLACK);

	pgFlipShowFrameV();
	
	while (1) {
		int i = 0;
		for (i = 0; i < 3; i++) {
			keyboardControl();
			testContact();
		}
		drawScreen();
	}
    return 0;
	} 
